#include <windows.h>
#include <winsock2.h>
#include "resource.h"
#include "netribaasi.h"

#define WSOCK_SELECT    (WM_USER + 2)

LPCSTR szWindowClass = "GAME_CLASS";
LPCSTR szWindowTitle = "ʐMΐ탊o[V";

int mode;
SOCKADDR_IN addr;
game_t game;
HINSTANCE hInst;
client_t clients[100];

void initclients(void) {
	int i;
	for(i=0;i<100;i++) {
		clients[i].sock=INVALID_SOCKET;
		clients[i].recvmode=-1;
		clients[i].recvedlen=0;
		clients[i].sendbufptr=0;
		clients[i].sendbufendptr=0;
	}
}

int findclient(SOCKET sock) {
	int i;
	for(i=0;i<100;i++) {
		if(clients[i].sock==sock)return i;
	}
	for(i=0;i<100;i++) {
		if(clients[i].sock==INVALID_SOCKET) {
			clients[i].sock=sock;
			clients[i].recvmode=-1;
			clients[i].recvedlen=0;
			clients[i].sendbufptr=0;
			clients[i].sendbufendptr=0;
			return i;
		}
	}
	return -1;
}

void wndresizebyclient(HWND hWnd,int x,int y) {
	RECT size;
	RECT wndsize;
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,x+wndsize.right-size.right,y+wndsize.bottom-size.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
}

BOOL CALLBACK DlgProc(HWND hDlg,UINT msg,WPARAM wp,LPARAM lp) {
	char buf[100];
	HOSTENT* host;
	switch(msg) {
		case WM_INITDIALOG:
			SendMessage(GetDlgItem(hDlg,IDC_EDITNAME),EM_SETLIMITTEXT,19,0);
			break;
		case WM_COMMAND:
			switch(LOWORD(wp)) {
				case IDOK:
					if(SendMessage(GetDlgItem(hDlg,IDC_CHKSERVER),BM_GETCHECK,0,0))
						mode=MODE_SERVER;
					else if(SendMessage(GetDlgItem(hDlg,IDC_CHKCLIENT),BM_GETCHECK,0,0))
						mode=MODE_CLIENT;
					else if(SendMessage(GetDlgItem(hDlg,IDC_CHKWATCH),BM_GETCHECK,0,0))
						mode=MODE_WATCH;
					else {
						MessageBox(hDlg,"[hIĂB",
							"error",MB_OK | MB_ICONWARNING);
						return FALSE;
					}
					GetWindowText(GetDlgItem(hDlg,IDC_EDITNAME),
						mode==MODE_SERVER?game.onename:game.twoname,20);
					if(lstrlen(mode==MODE_SERVER?game.onename:game.twoname)==0
							&& mode!=MODE_WATCH) {
						MessageBox(hDlg,"O͂ĂB",
							"error",MB_OK | MB_ICONWARNING);
						return FALSE;
					}
					GetWindowText(GetDlgItem(hDlg,IDC_EDITPORT),buf,100);
					if(lstrlen(buf)==0) {
						MessageBox(hDlg,"|[gԍ͂ĂB",
							"error",MB_OK | MB_ICONWARNING);
						return FALSE;
					}
					addr.sin_family=AF_INET;
					addr.sin_port=htons(atoi(buf));
					if(mode!=MODE_SERVER) {
						GetWindowText(GetDlgItem(hDlg,IDC_EDITIPADDR),buf,100);
						if(lstrlen(buf)==0) {
							MessageBox(hDlg,"T[o[͂ĂB",
								"error",MB_OK | MB_ICONWARNING);
							return FALSE;
						}
						addr.sin_addr.s_addr=inet_addr(buf);
						if(addr.sin_addr.s_addr==0xffffffff) {
							host=gethostbyname(buf);
							if(host==NULL) {
								MessageBox(hDlg,"T[o[ł܂B",
									"error",MB_OK | MB_ICONWARNING);
								return FALSE;
							}
							addr.sin_addr.s_addr=*((unsigned long*)host->h_addr);
						}
					} else {
						addr.sin_addr.s_addr=INADDR_ANY;
					}
					EndDialog(hDlg,1);
					return TRUE;
					break;
				case IDCANCEL:
					EndDialog(hDlg,0);
					return TRUE;
			}
			break;
		case WM_CLOSE:
			EndDialog(hDlg,0);
			return TRUE;
			break;
	}
	return FALSE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
	WSADATA wsaData;
    PAINTSTRUCT ps;
    HDC hdc;
    static HDC hgamendc;
    static HBITMAP hgamenbmp;
    static HBITMAP holdbmp;
    static int ret;
	static SOCKET sock=INVALID_SOCKET;
	static int inited=0;

    switch (message) {
		case WM_CREATE:
			/*EBhẼTCY*/
			wndresizebyclient(hWnd,640,480);
			/*rbg}bv̏*/
			hdc=GetDC(hWnd);
			hgamendc=CreateCompatibleDC(hdc);
			hgamenbmp=CreateCompatibleBitmap(hdc,640,480);
			holdbmp=(HBITMAP)SelectObject(hgamendc,hgamenbmp);
			ReleaseDC(hWnd,hdc);
			/*wininet̏*/
			ret=WSAStartup( MAKEWORD(1,1), &wsaData );
			if(ret!=0) {
				MessageBox(hWnd,"WSAStartupŃG[","error",MB_OK | MB_ICONWARNING);
				PostMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			/*ݒ_CAO*/
			if(DialogBox(hInst,"MODEDLG",hWnd,(DLGPROC)DlgProc)==0) {
				PostMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			/*\Pbg̏*/
			sock=socket(AF_INET,SOCK_STREAM,0);
			if(sock==INVALID_SOCKET) {
				MessageBox(hWnd,"\Pbg쐬Ɏs","error",MB_OK | MB_ICONWARNING);
				PostMessage(hWnd,WM_CLOSE,0,0);
			}
			if(WSAAsyncSelect(sock, hWnd, WSOCK_SELECT,
					FD_ACCEPT | FD_CONNECT | FD_READ | FD_WRITE | FD_CLOSE) == SOCKET_ERROR) {
				MessageBox(hWnd,"WSAAsyncSelectŃG[","error",MB_OK | MB_ICONWARNING);
				PostMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			initclients();
			if(mode==MODE_SERVER) {
				BOOL yes=1;
				setsockopt(sock,
					SOL_SOCKET, SO_REUSEADDR, (const char *)&yes, sizeof(yes));
				if(bind(sock,(struct sockaddr *)&addr,sizeof(addr))!=0) {
					MessageBox(hWnd,"bindŃG[","error",MB_OK | MB_ICONWARNING);
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				}
				if(listen(sock,5)!=0) {
					MessageBox(hWnd,"listenŃG[","error",MB_OK | MB_ICONWARNING);
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				}
				initgame(&game);
			} else {
				/*if(connect(sock,(struct sockaddr *)&addr,sizeof(addr))!=0) {
					MessageBox(hWnd,"connectŃG[","error",MB_OK | MB_ICONWARNING);
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				}*/
				int a=connect(sock,(struct sockaddr *)&addr,sizeof(addr));
				if(a!=0 && WSAGetLastError()!=WSAEWOULDBLOCK) {
					MessageBox(hWnd,"connectŃG[","error",MB_OK | MB_ICONWARNING);
					PostMessage(hWnd,WM_CLOSE,0,0);
					break;
				}
				SetTimer(hWnd,0,100,NULL);
			}
			TextOut(hgamendc,0,0,"ڑҋ@",10);
			InvalidateRect(hWnd,NULL,FALSE);
			break;
		case WM_KEYDOWN:
			if(inited==0)break;
			if(lParam & (1<<14))break;
			if(wParam==13) {/*EnterŐU𑊎ɏ*/
				if(mode==MODE_SERVER && inited==1) {
					game.nowturn=1;
					inited=2;
					drawboard(hgamendc,&game);
					InvalidateRect(hWnd,NULL,FALSE);
				}
			} else if(wParam==27) {/*EscōăQ[*/
				if(game.onepass && game.twopass) {
					if(mode==MODE_SERVER) {
						initgame(&game);
						inited=1;
						InvalidateRect(hWnd,NULL,FALSE);
					} else if(mode==MODE_CLIENT) {
						char buf=CMD_ONEMORE;
						int len;
						clients[0].sendbuf[clients[0].sendbufendptr]=buf;
						clients[0].sendbufendptr++;
						/*FD_WRITËꕔRsy*/
						len=send(sock,&clients[0].sendbuf[clients[0].sendbufptr],
							clients[0].sendbufendptr-clients[0].sendbufptr,0);
						if(len==SOCKET_ERROR) {
							if(WSAGetLastError()!=WSAEWOULDBLOCK) {
								MessageBox(hWnd,"ʐMG[0","error",MB_OK | MB_ICONWARNING);
							}
						} else {
							clients[0].sendbufptr+=len;
							if(clients[0].sendbufptr>=clients[0].sendbufendptr) {
								clients[0].sendbufptr=0;
								clients[0].sendbufendptr=0;
							}
						}
					}
				}
			}
			break;
		case WM_LBUTTONDOWN:
			if(inited==0)break;
			if((mode==MODE_SERVER && game.nowturn==0) ||
			   (mode==MODE_CLIENT && game.nowturn)) {
				int x,y;
				x=LOWORD(lParam);
				y=HIWORD(lParam);
				if(x>=20 && x<420 && y>=20 && y<420) {
					if(putkoma(&game,(x-20)/50,(y-20)/50,game.nowturn)) {
						game.nowturn=!game.nowturn;
						if(mode==MODE_CLIENT) {
							char buf[3];
							int len;
							buf[0]=CMD_PUT;
							buf[1]=(x-20)/50;
							buf[2]=(y-20)/50;
							memcpy(&clients[0].sendbuf[clients[0].sendbufendptr],buf,3);
							clients[0].sendbufendptr+=3;
							/*FD_WRITËꕔRsy*/
							len=send(sock,&clients[0].sendbuf[clients[0].sendbufptr],
								clients[0].sendbufendptr-clients[0].sendbufptr,0);
							if(len==SOCKET_ERROR) {
								if(WSAGetLastError()!=WSAEWOULDBLOCK) {
									MessageBox(hWnd,"ʐMG[0","error",MB_OK | MB_ICONWARNING);
								}
							} else {
								clients[0].sendbufptr+=len;
								if(clients[0].sendbufptr>=clients[0].sendbufendptr) {
									clients[0].sendbufptr=0;
									clients[0].sendbufendptr=0;
								}
							}
						} else {
							game.lastx=(x-20)/50;
							game.lasty=(y-20)/50;
							game.onepass=ispass(&game,0);
							game.twopass=ispass(&game,1);
							inited=2;
						}
						drawboard(hgamendc,&game);
						InvalidateRect(hWnd,NULL,FALSE);
					}
				}
			} 
			break;
		case WM_TIMER:
			if(wParam!=0)break;
			{
				char buf=CMD_GETSTAT;
				int len;
				clients[0].sendbuf[clients[0].sendbufendptr]=buf;
				clients[0].sendbufendptr++;
				/*FD_WRITËꕔRsy*/
				len=send(sock,&clients[0].sendbuf[clients[0].sendbufptr],
					clients[0].sendbufendptr-clients[0].sendbufptr,0);
				if(len==SOCKET_ERROR) {
					if(WSAGetLastError()!=WSAEWOULDBLOCK) {
						MessageBox(hWnd,"ʐMG[0","error",MB_OK | MB_ICONWARNING);
					}
				} else {
					clients[0].sendbufptr+=len;
					if(clients[0].sendbufptr>=clients[0].sendbufendptr) {
						clients[0].sendbufptr=0;
						clients[0].sendbufendptr=0;
					}
				}
			}
			break;
	    case WM_PAINT:
    	    hdc = BeginPaint(hWnd, &ps);
    	    BitBlt(hdc,0,0,640,480,hgamendc,0,0,SRCCOPY);
    	    if(inited==1)TextOut(hdc,50,440,"EnterŐU𑊎ɏ܂B",29);
        	EndPaint(hWnd, &ps);
        	break;
        case WSOCK_SELECT:
			{
				SOCKET sock2=(SOCKET)wParam;
				SOCKADDR_IN clientaddr;
				char buf[1000];
				int len;
				int client;
				int sendflag=0;
				if(mode==MODE_SERVER) {
					client=findclient(sock2);
					if(client==-1) {
						MessageBox(hWnd,"󂫃NCAg܂","error",MB_OK | MB_ICONWARNING);
						break;
					}
				} else client=0;
				switch(WSAGETSELECTEVENT(lParam)){
					case FD_ACCEPT:
						len=sizeof(clientaddr);
						accept(sock,(struct sockaddr *)&clientaddr,&len);
						break;
					case FD_CONNECT:
						if(mode==MODE_CLIENT) {
							buf[0]=CMD_SANKA;
							memcpy(&buf[1],game.twoname,20);
							memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,21);
							clients[client].sendbufendptr+=21;
							/*FD_WRITËꕔRsy*/
							len=send(sock2,&clients[client].sendbuf[clients[client].sendbufptr],
								clients[client].sendbufendptr-clients[client].sendbufptr,0);
							if(len==SOCKET_ERROR) {
								if(WSAGetLastError()!=WSAEWOULDBLOCK) {
									MessageBox(hWnd,"ʐMG[0","error",MB_OK | MB_ICONWARNING);
								}
							} else {
								clients[client].sendbufptr+=len;
								if(clients[client].sendbufptr>=clients[client].sendbufendptr) {
									clients[client].sendbufptr=0;
									clients[client].sendbufendptr=0;
								}
							}
						}
						break;
					case FD_READ:
						switch(clients[client].recvmode) {
							case -1:
								len=recv(sock2,buf,1,0);
								if(len==SOCKET_ERROR) {
									MessageBox(hWnd,"ʐMG[2","error",MB_OK | MB_ICONWARNING);
									break;
								}
								if(mode==MODE_SERVER) {
									switch(buf[0]) {
										case CMD_SANKA:
											if(inited==0) {
												clients[client].recvedlen=0;
												clients[client].recvmode=CMD_SANKA;
											} else {
												/*ɎQĂ*/
												buf[0]=CMD_NG;
												clients[client].sendbuf[clients[client].sendbufendptr]=buf[0];
												clients[client].sendbufendptr++;
												sendflag=1;
											}
											break;
										case CMD_GETSTAT:
											buf[0]=CMD_OK;
											memcpy(&buf[1],&game,sizeof(game));
											memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,sizeof(game)+1);
											clients[client].sendbufendptr+=sizeof(game)+1;
											sendflag=1;
											break;
										case CMD_PUT:
											clients[client].recvedlen=0;
											clients[client].recvmode=CMD_PUT;
											break;
										case CMD_ONEMORE:
											if(game.onepass==0 || game.twopass==0) {
												buf[0]=CMD_NG;
												memcpy(&buf[1],&game,sizeof(game));
												memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,sizeof(game)+1);
												clients[client].sendbufendptr+=sizeof(game)+1;
												sendflag=1;
												break;
											}
											initgame(&game);
											inited=1;
											buf[0]=CMD_OK;
											memcpy(&buf[1],&game,sizeof(game));
											memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,sizeof(game)+1);
											clients[client].sendbufendptr+=sizeof(game)+1;
											sendflag=1;
											break;
									}
								} else {
									if(buf[0]==CMD_OK) {
										clients[client].recvedlen=0;
										clients[client].recvmode=CMD_CLIENT;
									} else {
										if(inited)
											MessageBox(hWnd,"ʐMG[1","error",MB_OK | MB_ICONWARNING);
										else
											MessageBox(hWnd,"ʐMG[1\r\n"
											"ɎQĂ\܂B","error",MB_OK | MB_ICONWARNING);
										SendMessage(hWnd,WM_CLOSE,0,0);
									}
								}
								break;
							case CMD_SANKA:
								len=recv(sock2,&clients[client].recvbuf[clients[client].recvedlen],
									20-clients[client].recvedlen,0);
								if(len==SOCKET_ERROR) {
									MessageBox(hWnd,"ʐMG[2","error",MB_OK | MB_ICONWARNING);
									break;
								}
								clients[client].recvedlen+=len;
								if(clients[client].recvedlen>=20) {
									memcpy(buf,clients[client].recvbuf,20);
									clients[client].recvmode=-1;
									clients[client].recvedlen=0;
									if(inited==0) {
										initgame(&game);
										memcpy(game.twoname,buf,20);
										drawboard(hgamendc,&game);
										InvalidateRect(hWnd,NULL,FALSE);
										buf[0]=CMD_OK;
										memcpy(&buf[1],&game,sizeof(game));
										memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,sizeof(game)+1);
										clients[client].sendbufendptr+=sizeof(game)+1;
										sendflag=1;
										inited=1;
									} else {
										/*ɎQĂ*/
										buf[0]=CMD_NG;
										clients[client].sendbuf[clients[client].sendbufendptr]=buf[0];
										clients[client].sendbufendptr++;
										sendflag=1;
									}
								}
								break;
							case CMD_PUT:
								len=recv(sock2,&clients[client].recvbuf[clients[client].recvedlen],
									2-clients[client].recvedlen,0);
								if(len==SOCKET_ERROR) {
									MessageBox(hWnd,"ʐMG[3","error",MB_OK | MB_ICONWARNING);
									break;
								}
								clients[client].recvedlen+=len;
								if(clients[client].recvedlen>=2) {
									memcpy(buf,clients[client].recvbuf,2);
									clients[client].recvmode=-1;
									clients[client].recvedlen=0;
									if(!game.nowturn) {
										/*̔Ԃł͂Ȃ*/
										buf[0]=CMD_NG;
										clients[client].sendbuf[clients[client].sendbufendptr]=buf[0];
										clients[client].sendbufendptr++;
										sendflag=1;
										break;
									}
									if(!putkoma(&game,buf[0],buf[1],1)) {
										/*ɂ͒uȂ*/
										buf[0]=CMD_NG;
										clients[client].sendbuf[clients[client].sendbufendptr]=buf[0];
										clients[client].sendbufendptr++;
										sendflag=1;
										break;
									}
									game.nowturn=0;
									game.lastx=buf[0];
									game.lasty=buf[1];
									game.onepass=ispass(&game,0);
									game.twopass=ispass(&game,1);
									drawboard(hgamendc,&game);
									InvalidateRect(hWnd,NULL,FALSE);
									buf[0]=CMD_OK;
									memcpy(&buf[1],&game,sizeof(game));
									memcpy(&clients[client].sendbuf[clients[client].sendbufendptr],buf,sizeof(game)+1);
									clients[client].sendbufendptr+=sizeof(game)+1;
									sendflag=1;
								}
								break;
							case CMD_CLIENT:
								len=recv(sock2,&clients[client].recvbuf[clients[client].recvedlen],
									sizeof(game)-clients[client].recvedlen,0);
								if(len==SOCKET_ERROR) {
									MessageBox(hWnd,"ʐMG[4","error",MB_OK | MB_ICONWARNING);
									break;
								}
								clients[client].recvedlen+=len;
								if(clients[client].recvedlen>=sizeof(game)) {
									clients[client].recvmode=-1;
									clients[client].recvedlen=0;
									memcpy(&game,clients[client].recvbuf,sizeof(game));
									drawboard(hgamendc,&game);
									InvalidateRect(hWnd,NULL,FALSE);
									if(inited==0)inited=2;
								}
								break;
							default:
								MessageBox(hWnd,"M[hG[","error",MB_OK | MB_ICONWARNING);
								break;
						}
						if(!sendflag)break;
					case FD_WRITE:
						if(clients[client].sendbufptr>=clients[client].sendbufendptr) {
							clients[client].sendbufptr=0;
							clients[client].sendbufendptr=0;
							break;
						}
						len=send(sock2,&clients[client].sendbuf[clients[client].sendbufptr],
							clients[client].sendbufendptr-clients[client].sendbufptr,0);
						if(len==SOCKET_ERROR) {
							if(WSAGetLastError()!=WSAEWOULDBLOCK) {
								MessageBox(hWnd,"ʐMG[5","error",MB_OK | MB_ICONWARNING);
							}
						} else {
							clients[client].sendbufptr+=len;
							if(clients[client].sendbufptr>=clients[client].sendbufendptr) {
								clients[client].sendbufptr=0;
								clients[client].sendbufendptr=0;
							}
						}
						break;
					case FD_CLOSE:
						if(mode==MODE_SERVER) {
							shutdown(sock2,SD_BOTH);
							closesocket(sock2);
							clients[client].sock=INVALID_SOCKET;
						} else {
							MessageBox(hWnd,"ڑؒf܂","error",MB_OK | MB_ICONWARNING);
							PostMessage(hWnd,WM_CLOSE,0,0);
						}
						break;
				}
			}
			break;
    	case WM_DESTROY:
			if(ret==0) {
				if(sock!=INVALID_SOCKET) {
					shutdown(sock,SD_BOTH);
					closesocket(sock);
				}
				WSACleanup();
			}
			SelectObject(hgamendc,holdbmp);
			DeleteObject(holdbmp);
			DeleteDC(hgamendc);
        	PostQuitMessage(0);
        	break;
    	default:
        	return DefWindowProc(hWnd, message, wParam, lParam);
   	}

    return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    MSG msg;
    WNDCLASSEX wcex;
    HWND hWnd;

	hInst=hInstance;
    wcex.cbSize = sizeof(WNDCLASSEX);

    wcex.style          = CS_HREDRAW | CS_VREDRAW;
    wcex.lpfnWndProc    = (WNDPROC)WndProc;
    wcex.cbClsExtra     = 0;
    wcex.cbWndExtra     = 0;
    wcex.hInstance      = hInstance;
    wcex.hIcon          = LoadIcon(NULL,IDI_APPLICATION);
    wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
    wcex.lpszMenuName   = NULL;
    wcex.lpszClassName  = szWindowClass;
    wcex.hIconSm        = NULL;

    RegisterClassEx(&wcex);

    hWnd = CreateWindow(szWindowClass,
        szWindowTitle, WS_OVERLAPPEDWINDOW &
		~WS_MAXIMIZEBOX & ~WS_THICKFRAME,
        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
        NULL, NULL, hInstance, NULL);

    if (!hWnd)
        return FALSE;

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;
}
